<template>
  <div class="app-container">
    <crud-table
      @getList="fetchCollection"
      @go="go"
      @remove="remove"
      :resourceName="resourceName"
      :rows="collection.data"
      :columns="columns"
      :loading="loading"
    >
      <el-row :gutter="20" slot="filters" class="filters">
        <el-col :span="8">
        <el-input
          v-model="query.name.$search"
          @input="debouncedFetchCollection"
          placeholder="Nombre"
          clearable />
        </el-col>
        <el-col :span="8">
          <el-select
            @input="debouncedFetchCollection"
            v-model="query.category.$in"
            placeholder="Categorías" multiple collapse-tags>
            <el-option
              v-for="(category, idx) in productCategories"
              :key="idx"
              :label="category"
              :value="category">
            </el-option>
          </el-select>
        </el-col>
        <el-col :span="8">
          <el-select
            @input="debouncedFetchCollection"
            v-model="query.brand.$in"
            placeholder="Marca" multiple collapse-tags>
            <el-option
              v-for="(brand, idx) in productBrands"
              :key="idx"
              :label="brand"
              :value="brand">
            </el-option>
          </el-select>
        </el-col>
      </el-row>
    </crud-table>
    <el-pagination
      background
      @current-change="paginate"
      layout="prev, pager, next"
      :page-size="collection.limit"
      :total="collection.total">
    </el-pagination>
  </div>
</template>

<script>
import api from "@/feathers";
import CrudTable from "@/common/crud-table.component";
import CrudTableMixin from "@/common/crud-table.mixin";
import { debounce } from "lodash";
import { formatCurrency } from "../../filters";

export default {
  name: "products-list",
  mixins: [CrudTableMixin],
  components: {
    CrudTable
  },
  data() {
    return {
      resourceName: {
        singular: "Product",
        plural: "Products"
      },
      collection: {
        data: [],
        total: 0
      },
      columns: [
        { prop: "code", label: "ID", minWidth: 30 },
        { prop: "name", label: "Nombre", minWidth: 160 },
        { prop: "category", label: "Categoría", minWidth: 80 },
        {
          prop: "price",
          label: "Precio",
          minWidth: 80,
          formatter: this.formatPrice
        },
        { prop: "brand", label: "Marca", minWidth: 80 }
      ],
      query: {
        name: { $search: "" },
        category: { $in: [] },
        brand: { $in: [] },
        $limit: 10,
        $skip: 0
      },
      productCategories: [],
      productBrands: [],
      loading: false
    };
  },
  async created() {
    this.routePrefix = "products";
    this.service = api.service("products");

    await Promise.all([this.getCategories(), this.getBrands()]);
    await this.fetchCollection();
  },
  methods: {
    async debouncedFetchCollection() {
      return debounce(this.fetchCollection, 500)();
    },
    async fetchCollection() {
      this.loading = true;
      const response = await this.service.find({
        query: this.query
      });
      this.collection = response;
      this.loading = false;
    },
    formatPrice(row, { property }) {
      return formatCurrency(row[property]);
    },
    async getCategories() {
      this.loading = true;
      this.productCategories = await api.service("product-categories").find();
      this.query.category.$in = this.productCategories.slice();
      this.loading = false;
    },
    async getBrands() {
      this.loading = true;
      this.productBrands = await api.service("product-brands").find();
      this.query.brand.$in = this.productBrands.slice();
      this.loading = false;
    }
  }
};
</script>
